states: Rename openstack, add baremetal_init
[fuel.git] / mcp / config / states / virtual_control_plane
index ec8fc9c..5de4673 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/bash -x
+#!/bin/bash -e
 ##############################################################################
 # Copyright (c) 2017 Mirantis Inc., Enea AB and others.
 # All rights reserved. This program and the accompanying materials
@@ -7,23 +7,29 @@
 # http://www.apache.org/licenses/LICENSE-2.0
 ##############################################################################
 
+CI_DEBUG=${CI_DEBUG:-0}; [[ "${CI_DEBUG}" =~ (false|0) ]] || set -x
+ERASE_ENV=${ERASE_ENV:-0}
+
 # shellcheck disable=SC1090
 source "$(dirname "${BASH_SOURCE[0]}")/../../scripts/lib.sh"
 
-# KVM, compute node prereqs (libvirt first), VCP deployment
-salt -C 'kvm*' pkg.install bridge-utils
-salt -C 'kvm*' state.apply linux.network
-salt -C 'cmp*' state.apply linux.system
-salt -C 'kvm* or cmp*' system.reboot
-wait_for 90 "! salt -C 'kvm* or cmp*' test.ping | " \
-  "tee /dev/stderr | grep -Fq 'Not connected'"
-
-salt -C '* and not cfg01* and not mas01*' state.apply linux,ntp
+# Optionally destroy VCP VMs from a previous run
+if [ "${ERASE_ENV}" -eq 1 ]; then
+    kvm_vms=$(salt --out yaml 'kvm*' virt.list_domains | \
+              sed -e 's/- //g' -e 's/:.*$//g')
+    for line in ${kvm_vms}; do
+        if [[ "${line}" =~ ^kvm ]]; then
+            kvm_node=${line}
+        elif [ -n "${kvm_node}" ]; then
+            salt "${kvm_node}" virt.purge dirs=True "${line}" || true
+        fi
+    done
+fi
 
-salt -C 'kvm*' state.sls libvirt
+# KVM libvirt first, VCP deployment
+wait_for 5 "salt -C 'kvm*' state.sls libvirt"
 
-salt -C '* and not cfg01* and not mas01*' state.apply salt
-salt -C 'kvm*' saltutil.sync_all
+salt -C 'kvm* or cmp*' state.apply salt
 wait_for 10 "! salt -C 'kvm*' state.sls salt.control | " \
   "tee /dev/stderr | grep -Fq 'Not connected'"
 
@@ -32,12 +38,15 @@ vcp_nodes=$(salt --out yaml 'kvm01*' pillar.get salt:control:cluster:internal:no
 
 # Check all vcp nodes are available
 rc=1
-while [ $rc -ne 0 ]; do
+attempt=0
+total_attempts=50
+while [ $rc -ne 0 ] && [ ${attempt} -lt ${total_attempts} ]; do
   rc=0
   for node in $vcp_nodes; do
     salt "$node" test.ping 2>/dev/null || { rc=$?; break; };
   done
   sleep 5
+  ((attempt+=1))
 done
 
 wait_for 10 "salt -C '* and not cfg01* and not mas01*' saltutil.sync_all"
@@ -47,3 +56,10 @@ wait_for 10 "! salt -C 'E@^(?!cfg01|mas01|kvm|cmp00).*' state.apply linux,ntp |
 
 wait_for 10 "salt -C 'E@^(?!cfg01|mas01|kvm|cmp00).*' ssh.set_auth_key ${SUDO_USER} \
   $(awk 'NR==1{print $2}' "$(eval echo "~${SUDO_USER}/.ssh/authorized_keys")")"
+
+# Disable proxy dhcp routes after installation
+salt -C 'prx*' file.write /etc/dhcp/dhclient-enter-hooks.d/no-default-route \
+  args='unset new_routers'
+salt -C 'prx*' system.reboot
+wait_for 30 "! salt -C 'prx*' test.ping | " \
+  "tee /dev/stderr | grep -Fq 'Not connected'"